Program Ray_Casting;

Uses Crt,Graph;


Const
       {A falakat felepito kockak 64*64*64 -esek lesznek}
       WALLSIZE=64;
       WALLSHIFT=6; {2^6=64}
       GRIDX=WALLSIZE; {a tombindexelesnel igy konnyebb lesz}
       GRIDY=WALLSIZE;


{A palya :}
      GridMap : array[0..GRIDY-1,0..GRIDX-1] of char=
      (
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                   *                                           ',
       '                                                               ',
       '                                   ***                         ',
       '                                                               ',
       '                                                               ',
       '                                                ********       ',
       '                                                *      **      ',
       '                                              ***       ****   ',
       '                                              *            *   ',
       '        *                                    **            *   ',
       '                                            **             *   ',
       '                                           **      ***** ***   ',
       '                      **********************       *   * *     ',
       '                                                   *   * *     ',
       '                      ******************************   * *     ',
       '                                                       * *     ',
       '                    ************************           * *     ',
       '                    *                      *           * *     ',
       '                    ****                   *    ******** *     ',
       '                    *  *      *            *    *        *     ',
       '                    *  *         **        *    *  *******     ',
       '                    *            **        ******  *           ',
       '                    *         *                    *           ',
       '                    *       *              *********           ',
       '                    *      **              *                   ',
       '                    ****          ***      *                   ',
       '                       *          * *      *                   ',
       '                       *          ***      *                   ',
       '                       *********************                   ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ',
       '                                                               ');

       {egypar szogertek (360 helyett 2048-ra osztottuk fel a kort)}
       ANG_90=512;
       ANG_360=2048;
       ANG_0=0;
       ANG_180=1024;
       ANG_270=1536;
       {A szogfuggvenytablazatok ennyivel lesznek felszorozva}
       TABSHIFT=15;
       TABMUL=32768; {2^15}
       {latomezo 2048-as fokban (normalisan 60 fok)}
       FOV=340;
       {lekepezesi sik adatai}
       XMAX=319;
       YMAX=199;
       YHALF=100;
       XHALF=160;


Var SinT,CosT,TanT,CtanT : array[0..ANG_360-1] of longint;
    ColorMap : array[0..GRIDY-1,0..GRIDX-1] of byte;     {falegysegekhez tartozo szinek}
    AoRT : array[0..XMAX] of integer;    {Angle of Ray table}
    c : char;
    Px,Py,AoV : longint;        {nezo adatai (hely, nezetszog)}
    HeightScale : longint;      {lekepezeshez}
    screen : TScreen320X200;

Procedure FillTabs;
var i : integer;
    rad,a : real;
    x,y : integer;
begin
      {szogfuggvenytablazatok}
      for i:=0 to ANG_360-1 do
      begin
            rad:=PI*i/ANG_180;
            SinT[i]:=trunc(TABMUL*sin(rad));
            CosT[i]:=trunc(TABMUL*cos(rad));
            if (i=ANG_90) or (i=ANG_270) then TanT[i]:=MaxInt*TABMUL
            else TanT[i]:=trunc(TABMUL*sin(rad)/cos(rad));
            if (i=ANG_0) or (i=ANG_180) then CtanT[i]:=MaxInt*TABMUL
            else CtanT[i]:=trunc(TABMUL*cos(rad)/sin(rad));
      end;

      {a sugar szoge minden kepernyooszlopra}
      for i:=0 to XMAX do
      begin
        a:=FOV/2-i*FOV/XMAX;
        AoRT[i]:=trunc(a);
      end;

      {HeightScale=WSIZE/160*tan(FOV/2)  TABSHIFT-el balra leptetve}
      HeightScale:=trunc(TABMUL*WALLSIZE*(XHALF*sin(PI*FOV/2048)/cos(PI*FOV/2048)));

      {Minden egyes falkockanak veletlenszeru szine lesz}
      for y:=0 to GRIDY-1 do
          for x:=0 to GRIDX-1 do
                colormap[y,x]:=random(14)+1;

end;


{fuggoleges fal keresese, tavolsag visszaadasa}
{fal koordinatak vX,vY-ba mennek}
function findXWall(var vX, vY : longint;a : integer) : integer;
var DeltaY, DeltaX, X, Y : longint;
    Grids : ^char;
begin
      findXwall:=MaxInt; {ha nincs fal, a leheto legnagyobb tavolsagot adjuk vissza}
      Grids:=@GridMap;
      {parhuzamos falakat nem metszhet a sugar}
      if (a=ANG_0) or (a=ANG_180) then exit;

      {felfele megy a sugar}
      if (a>ANG_0) and (a<ANG_180) then
      begin
            Y:=(vY and (-WALLSIZE))-1;
            DeltaY:=-WALLSIZE;
      end;
      {lefele megya sugar}
      if (a>ANG_180) and (a<ANG_360) then
      begin
            Y:=(vY and (-WALLSIZE))+WALLSIZE;
            DeltaY:=WALLSIZE;
      end;
      DeltaX:=-DeltaY*cTant[a];
      X:=(vX shl TABSHIFT)+(vY-Y)*ctanT[a];

      {rajta vagyunk-e a terkepen}
      if (X<0) or (X>=GRIDX*TABMUL*WALLSIZE) or (Y<0) or (Y>=GRIDX*WALLSIZE) then exit;

      while ((Grids+(Y and (-GRIDX)) + (X shr (TABSHIFT+WALLSHIFT)))^=' ') do
      begin
            {lepeskozok hozzaadasa}
            X:=X+DeltaX;
            Y:=Y+DeltaY;
            {rajta vagyunk-e a terkepen}
            if (X<0) or (X>=GRIDX*TABMUL*WALLSIZE) or (Y<0) or (Y>=GRIDX*WALLSIZE) then exit;
      end;

      {tavolsag visszaadasa}
      findXwall:=abs(((y-vY) shl TABSHIFT) div SinT[a]);

      {falkoordinatak atadasa}
      vX:=X shr TABSHIFT;
      vY:=Y;
end;

function findYWall(var vX,vY : longint;a : integer) : integer;
var DeltaY, DeltaX, X, Y : longint;
    Grids : ^char;
begin
      findYWall:=MaxInt; {ha nincs fal, a leheto legnagyobb tavolsagot adjuk vissza}
      Grids:=@GridMap;

      {parhuzamos falakat nem metszhet a sugar}
      if (a=ANG_90) or (a=ANG_270) then exit;

      {jobbra megy a sugar}
      if (a<ANG_90) or (a>ANG_270) then
      begin
            X:=(vX and -WALLSIZE)+WALLSIZE;
            DeltaX:=WALLSIZE;
      end;
      {balra megy a sugar}
      if (a>ANG_90) and (a<ANG_270) then
      begin
            X:=(vX and -WALLSIZE)-1;
            DeltaX:=-WALLSIZE;
      end;

      {TABSHIFT -el balra tolt erteket kapunk (fixpontos szam)}
      Y:=(vY shl TABSHIFT)+(vX-X)*tanT[a];
      DeltaY:=-DeltaX*tanT[a];

      {ha kimentunk a palyarol, akkor biztos nincs fal}
      if (X<0) or (X>=GRIDX*WALLSIZE) or (Y<0) or (Y>=GRIDX*WALLSIZE*TABMUL) then exit;

      while ((Grids+((Y shr TABSHIFT) and -GRIDX)+(X shr WALLSHIFT))^=' ') do
      begin
            {lepekozok}
            X:=X+DeltaX;
            Y:=Y+DeltaY;
            {ha kimentunk a palyarol, akkor biztos nincs fal}
            if (X<0) or (X>=GRIDX*WALLSIZE) or (Y<0) or (Y>=GRIDX*WALLSIZE*TABMUL) then exit;
      end;

      {A tavolsag visszaadasa}
      findYwall:=abs((longint(x-vx) shl TABSHIFT) div CosT[a]);

      {a fal koordinatainak atadasa}
      vX:=X;
      vY:=Y shr TABSHIFT;
end;

{fuggoleges vonal kirajzolaasa}
procedure Vline(x,start,stop : integer; c : byte);
var Y : integer;
begin
      if (stop<start) or (stop=start) then exit;
      if stop<0 then exit;

      {clipping}
      if start<0 then start:=0;
      if stop>YMAX+1 then stop:=YMAX+1;

      for Y:=start to stop-1 do
      begin
            screen[Y,X]:=c;
      end;
end;

{kepernyo felepitese}
{Hasznalt kulso valtozok : Aov - nezetszog Angle of View
                           Px,Py - nezo pozizioja (64-el felszorozva}
procedure BuildScreen;
var a,b,col : integer;
    Xdist, Ydist, dist : integer;
    Z : longint;
    H,StartY,EndY : integer;
    xX,yX,xY,yY : longint;
    c : byte;
begin
    {oszloprol oszlopra}
    for col:=0 to 319 do
    begin
          {nezetszoghoz viszonyitott relativ szog}
          b:=AoRT[col] and (ANG_360-1);
          {abszolut szog}
          a:=(AoV+b) and (ANG_360-1);

          xX:=px;yX:=py;xY:=px;yY:=py;
          Xdist:=findXWall(xX,yX,a);
          Ydist:=findYWall(xY,yY,a);
          {A ket tavolsag kozul a kisebb kell}
          if Xdist<Ydist then
          begin
                dist:=Xdist;
                c := colormap[yX shr WALLSHIFT,xX  shr WALLSHIFT];
          end
          else
          begin
                dist:=Ydist;
                c := colormap[yY shr WALLSHIFT,xY shr WALLSHIFT];
          end;

          {halszem korrekcio}
          Z:=abs(CosT[b]*dist);
          {magassagot kiszamoljuk}
          H:=(HeightScale div Z);

          {vonal kirajzolasa}
          StartY:=YHALF-H;
          EndY:=YHALF+H;
          VLine(col,StartY,EndY,c);
    end;
end;

{megenezzuk, hogy ralephetunk-e az adott helyre}
function CheckGrid(X, Y : integer) : boolean;
begin
      CheckGrid:=FALSE;
      {Nem mehetunk ki a palyarol}
      if (X<0) or (X>=GRIDX*WALLSIZE) or (Y<0) or (Y>=GRIDY*WALLSIZE) then exit;
      {Ha ures a hely, akkor jo}
      if GridMap[Y div WALLSIZE,X div WALLSIZE]=' ' then CheckGrid:=TRUE;
end;

begin
      FillTabs;
      Init320X200;
      Px:=WALLSIZE*32;
      Py:=WALLSIZE*32;
      AoV:=ANG_180;
      repeat
        BuildScreen;
        disp320X200(screen);
        fill320X200(screen,0);
        c:=readkey;
        if c=#0 then
        begin
                c:=readkey;
                case c of
                    #72 : begin  {fel}
                             if CheckGrid(Px+(cost[Aov] div 5000),Py-(sint[Aov] div 5000))
                             then begin
                                inc(Px,cost[Aov] div 3000);
                                dec(Py,sint[Aov] div 3000);
                             end;
                           end;
                    #80 : begin  {le}
                             if CheckGrid(Px-(cost[Aov] div 5000),Py+(sint[Aov] div 5000))
                             then begin
                                dec(Px,cost[Aov] div 3000);
                                inc(Py,sint[Aov] div 3000);
                             end;
                           end;
                    #75 : AoV:=(AoV+24) and (ANG_360-1); {balra}
                    #77 : AoV:=(Aov-24) and (ANG_360-1); {jobbra}
                end;
       end;
      until c=#27;      {ESC-re ki}

      CloseGraph;       {CSA}

End.